/**
 * SLISTPQ.java
 *
 * File generated from the medication::SLISTPQ uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class SLISTPQ.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SLIST_PQ", propOrder = {
	"origin",
	"scale",
	"digits"
})
@XmlRootElement(name = "SLIST_PQ")
public class SLISTPQ extends net.ihe.gazelle.medication.ANY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                       The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                            .
	 */
	@XmlElement(name = "origin", required = true, namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.PQ origin;
	/**
	 *                       A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                            .
	 */
	@XmlElement(name = "scale", required = true, namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.PQ scale;
	/**
	 *                       A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                   .
	 */
	@XmlElement(name = "digits", required = true, namespace = "urn:epsos-org:ep:medication")
	public java.lang.String digits;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return origin.
	 * @return origin :                       The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                            
	 */
	public net.ihe.gazelle.medication.PQ getOrigin() {
	    return origin;
	}
	
	/**
	 * Set a value to attribute origin.
	 * @param origin :                       The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                                                  The origin of the list item
	                                value scale, i.e., the                      physical quantity that a
	                                zero-digit in the sequence                      would represent.
	                            .
	 */
	public void setOrigin(net.ihe.gazelle.medication.PQ origin) {
	    this.origin = origin;
	}
	
	
	
	
	/**
	 * Return scale.
	 * @return scale :                       A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                            
	 */
	public net.ihe.gazelle.medication.PQ getScale() {
	    return scale;
	}
	
	/**
	 * Set a value to attribute scale.
	 * @param scale :                       A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                                                  A ratio-scale quantity that is
	                                factored out of the                      digit sequence.
	                            .
	 */
	public void setScale(net.ihe.gazelle.medication.PQ scale) {
	    this.scale = scale;
	}
	
	
	
	
	/**
	 * Return digits.
	 * @return digits :                       A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                   
	 */
	public java.lang.String getDigits() {
	    return digits;
	}
	
	/**
	 * Set a value to attribute digits.
	 * @param digits :                       A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                                         A sequence of raw digits for the
	                                sample values. This is                      typically the raw output
	                                of an A/D converter.                   .
	 */
	public void setDigits(java.lang.String digits) {
	    this.digits = digits;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "SLIST_PQ").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SLISTPQ sLISTPQ, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (sLISTPQ != null){
   			net.ihe.gazelle.medication.ANY.validateByModule(sLISTPQ, location, cvm, diagnostic);
			net.ihe.gazelle.medication.PQ.validateByModule(sLISTPQ.getOrigin(), location + "/origin", cvm, diagnostic);
			net.ihe.gazelle.medication.PQ.validateByModule(sLISTPQ.getScale(), location + "/scale", cvm, diagnostic);
    	}
    }

}